typedef enum {
  p_none,
  p_code,
  p_ret,
  p_astart,
  p_aend,
  p_def,
  p_if,
  p_ifelse,
  p_loop,
  p_repeat,
  p_for,
  p_forall,
  p_exit,
  p_return,
  p_array,
  p_get,
  p_put,
  p_length,
  p_dup,
  p_pop,
  p_exch,
  p_rot,
  p_roll,
  p_over,
  p_index,
  p_exec,
  p_add,
  p_sub,
  p_mul,
  p_div,
  p_mod,
  p_neg,
  p_abs,
  p_min,
  p_max,
  p_and,
  p_or,
  p_xor,
  p_not,
  p_shl,
  p_shr,
  p_eq,
  p_ne,
  p_gt,
  p_ge,
  p_lt,
  p_le,
  p_trace,
  p_dtrace,
  p_malloc,
  p_free,
  p_realloc,
  p_memsize,
  p_dumpmem,
  p_gettype,
  p_settype,
  p_screensize,
  p_imagecolors,
  p_vscreensize,
  p_monitorsize,
  p_displaysizes,
  p_screenframebuffer,
  p_moveto,
  p_currentpoint,
  p_lineto,
  p_setcolor,
  p_currentcolor,
  p_putpixel,
  p_getpixel,
  p_setfont,
  p_currentfont,
  p_fontheight,
  p_strsize,
  p_show,
  p_settextmodecolor,
  p_image,
  p_loadpalette,
  p_setpalette,
  p_getpalette,
  p_settransparentcolor,
  p_savescreen,
  p_restorescreen,
  p_fillrect,
  p_snprintf,
  p_editinit,
  p_editdone,
  p_editinput,
  p_editshowcursor,
  p_edithidecursor,
  p_editredraw,
  p_editgetleft,
  p_rmoveto,
  p_strstr,
  p_soundgetvolume,
  p_soundsetvolume,
  p_soundgetsamplerate,
  p_soundsetsamplerate,
  p_soundplay,
  p_sounddone,
  p_modload,
  p_modplay,
  p_modplaysample,
  p_wavplay,
  p_wavplaylater,
  p_settextwrap,
  p_currenttextwrap,
  p_seteotchar,
  p_currenteotchar,
  p_settextcolors,
  p_currenttextcolors,
  p_setmaxrows,
  p_currentmaxrows,
  p_formattext,
  p_gettextrows,
  p_setstartrow,
  p_getlinks,
  p_setlink,
  p_currentlink,
  p_getlink,
  p_lineheight,
  p_currenttitle,
  p_usleep,
  p_notimeout,
  p_time,
  p_date,
  p_idle,
  p_imagesize,
  p_eject,
  p_poweroff,
  p_reboot,
  p_64bit,
  p_getbyte,
  p_putbyte,
  p_getword,
  p_putword,
  p_getdword,
  p_putdword,
  p_inbyte,
  p_outbyte,
  p_findfile,
  p_filesize,
  p_getcwd,
  p_chdir,
  p_mount,
  p_setmode,
  p_currentmode,
  p_videomodeinfo,
  p_videomodes,
  p_colorbits,
  p_setimage,
  p_currentimage,
  p_settransparency,
  p_currenttransparency,
  p_unpackimage,
  p_keepmode,
  p_blend,
  p_memcpy,
  p_sysconfig,
  p__readsector,
  p_sysinfo,
  p_getkey,
  p_serialinit,
  p_serialputc,
  p_serialsetconfig,
  p_serialgetbaud,
  p_realpath,
  p_systempath,
  p_xxx,
  p_test1,
  p_test2,
  p_test3,
  p_test4,
  p_test5,
  p_test6
} prim_t;

struct {
  type_t type;
  unsigned value;
  char *name;
} prim_names[] = {
  { t_none, 0, "KeyEvent" },
  { t_none, 0, "MenuInit" },
  { t_none, 0, "InfoBoxInit" },
  { t_none, 0, "InfoBoxDone" },
  { t_none, 0, "ProgressInit" },
  { t_none, 0, "ProgressDone" },
  { t_none, 0, "ProgressUpdate" },
  { t_none, 0, "PasswordInit" },
  { t_none, 0, "PasswordDone" },
  { t_none, 0, "Timeout" },
  { t_none, 0, "Timer" },
  { t_prim, p_code, "{" },
  { t_prim, p_ret, "{" },
  { t_prim, p_astart, "[" },
  { t_prim, p_aend, "]" },
  { t_prim, p_def, "def" },
  { t_prim, p_if, "if" },
  { t_prim, p_ifelse, "ifelse" },
  { t_prim, p_loop, "loop" },
  { t_prim, p_repeat, "repeat" },
  { t_prim, p_for, "for" },
  { t_prim, p_forall, "forall" },
  { t_prim, p_exit, "exit" },
  { t_prim, p_return, "return" },
  { t_prim, p_array, "array" },
  { t_prim, p_get, "get" },
  { t_prim, p_put, "put" },
  { t_prim, p_length, "length" },
  { t_prim, p_dup, "dup" },
  { t_prim, p_pop, "pop" },
  { t_prim, p_exch, "exch" },
  { t_prim, p_rot, "rot" },
  { t_prim, p_roll, "roll" },
  { t_prim, p_over, "over" },
  { t_prim, p_index, "index" },
  { t_prim, p_exec, "exec" },
  { t_prim, p_add, "add" },
  { t_prim, p_sub, "sub" },
  { t_prim, p_mul, "mul" },
  { t_prim, p_div, "div" },
  { t_prim, p_mod, "mod" },
  { t_prim, p_neg, "neg" },
  { t_prim, p_abs, "abs" },
  { t_prim, p_min, "min" },
  { t_prim, p_max, "max" },
  { t_prim, p_and, "and" },
  { t_prim, p_or, "or" },
  { t_prim, p_xor, "xor" },
  { t_prim, p_not, "not" },
  { t_prim, p_shl, "shl" },
  { t_prim, p_shr, "shr" },
  { t_prim, p_eq, "eq" },
  { t_prim, p_ne, "ne" },
  { t_prim, p_gt, "gt" },
  { t_prim, p_ge, "ge" },
  { t_prim, p_lt, "lt" },
  { t_prim, p_le, "le" },
  { t_prim, p_trace, "trace" },
  { t_prim, p_dtrace, "dtrace" },
  { t_prim, p_malloc, "malloc" },
  { t_prim, p_free, "free" },
  { t_prim, p_realloc, "realloc" },
  { t_prim, p_memsize, "memsize" },
  { t_prim, p_dumpmem, "dumpmem" },
  { t_prim, p_gettype, "gettype" },
  { t_prim, p_settype, "settype" },
  { t_prim, p_screensize, "screen.size" },
  { t_prim, p_imagecolors, "image.colors" },
  { t_prim, p_vscreensize, "vscreen.size" },
  { t_prim, p_monitorsize, "monitorsize" },
  { t_prim, p_displaysizes, "displaysizes" },
  { t_prim, p_screenframebuffer, "screen.framebuffer" },
  { t_prim, p_moveto, "moveto" },
  { t_prim, p_currentpoint, "currentpoint" },
  { t_prim, p_lineto, "lineto" },
  { t_prim, p_setcolor, "setcolor" },
  { t_prim, p_currentcolor, "currentcolor" },
  { t_prim, p_putpixel, "putpixel" },
  { t_prim, p_getpixel, "getpixel" },
  { t_prim, p_setfont, "setfont" },
  { t_prim, p_currentfont, "currentfont" },
  { t_prim, p_fontheight, "fontheight" },
  { t_prim, p_strsize, "strsize" },
  { t_prim, p_show, "show" },
  { t_prim, p_settextmodecolor, "settextmodecolor" },
  { t_prim, p_image, "image" },
  { t_prim, p_loadpalette, "loadpalette" },
  { t_prim, p_setpalette, "setpalette" },
  { t_prim, p_getpalette, "getpalette" },
  { t_prim, p_settransparentcolor, "settransparentcolor" },
  { t_prim, p_savescreen, "savescreen" },
  { t_prim, p_restorescreen, "restorescreen" },
  { t_prim, p_fillrect, "fillrect" },
  { t_prim, p_snprintf, "snprintf" },
  { t_prim, p_editinit, "edit.init" },
  { t_prim, p_editdone, "edit.done" },
  { t_prim, p_editinput, "edit.input" },
  { t_prim, p_editshowcursor, "edit.showcursor" },
  { t_prim, p_edithidecursor, "edit.hidecursor" },
  { t_prim, p_editredraw, "edit.redraw" },
  { t_prim, p_editgetleft, "edit.getleft" },
  { t_prim, p_rmoveto, "rmoveto" },
  { t_prim, p_strstr, "strstr" },
  { t_prim, p_soundgetvolume, "sound.getvolume" },
  { t_prim, p_soundsetvolume, "sound.setvolume" },
  { t_prim, p_soundgetsamplerate, "sound.getsamplerate" },
  { t_prim, p_soundsetsamplerate, "sound.setsamplerate" },
  { t_prim, p_soundplay, "sound.play" },
  { t_prim, p_sounddone, "sound.done" },
  { t_prim, p_modload, "mod.load" },
  { t_prim, p_modplay, "mod.play" },
  { t_prim, p_modplaysample, "mod.playsample" },
  { t_prim, p_wavplay, "wav.play" },
  { t_prim, p_wavplaylater, "wav.playlater" },
  { t_prim, p_settextwrap, "settextwrap" },
  { t_prim, p_currenttextwrap, "currenttextwrap" },
  { t_prim, p_seteotchar, "seteotchar" },
  { t_prim, p_currenteotchar, "currenteotchar" },
  { t_prim, p_settextcolors, "settextcolors" },
  { t_prim, p_currenttextcolors, "currenttextcolors" },
  { t_prim, p_setmaxrows, "setmaxrows" },
  { t_prim, p_currentmaxrows, "currentmaxrows" },
  { t_prim, p_formattext, "formattext" },
  { t_prim, p_gettextrows, "gettextrows" },
  { t_prim, p_setstartrow, "setstartrow" },
  { t_prim, p_getlinks, "getlinks" },
  { t_prim, p_setlink, "setlink" },
  { t_prim, p_currentlink, "currentlink" },
  { t_prim, p_getlink, "getlink" },
  { t_prim, p_lineheight, "lineheight" },
  { t_prim, p_currenttitle, "currenttitle" },
  { t_prim, p_usleep, "usleep" },
  { t_prim, p_notimeout, "notimeout" },
  { t_prim, p_time, "time" },
  { t_prim, p_date, "date" },
  { t_prim, p_idle, "idle" },
  { t_prim, p_imagesize, "image.size" },
  { t_prim, p_eject, "eject" },
  { t_prim, p_poweroff, "poweroff" },
  { t_prim, p_reboot, "reboot" },
  { t_prim, p_64bit, "64bit" },
  { t_prim, p_getbyte, "getbyte" },
  { t_prim, p_putbyte, "putbyte" },
  { t_prim, p_getword, "getword" },
  { t_prim, p_putword, "putword" },
  { t_prim, p_getdword, "getdword" },
  { t_prim, p_putdword, "putdword" },
  { t_prim, p_inbyte, "inbyte" },
  { t_prim, p_outbyte, "outbyte" },
  { t_prim, p_findfile, "findfile" },
  { t_prim, p_filesize, "filesize" },
  { t_prim, p_getcwd, "getcwd" },
  { t_prim, p_chdir, "chdir" },
  { t_prim, p_mount, "mount" },
  { t_prim, p_setmode, "setmode" },
  { t_prim, p_currentmode, "currentmode" },
  { t_prim, p_videomodeinfo, "videomodeinfo" },
  { t_prim, p_videomodes, "videomodes" },
  { t_prim, p_colorbits, "colorbits" },
  { t_prim, p_setimage, "setimage" },
  { t_prim, p_currentimage, "currentimage" },
  { t_prim, p_settransparency, "settransparency" },
  { t_prim, p_currenttransparency, "currenttransparency" },
  { t_prim, p_unpackimage, "unpackimage" },
  { t_prim, p_keepmode, "keepmode" },
  { t_prim, p_blend, "blend" },
  { t_prim, p_memcpy, "memcpy" },
  { t_prim, p_sysconfig, "sysconfig" },
  { t_prim, p__readsector, "_readsector" },
  { t_prim, p_sysinfo, "sysinfo" },
  { t_prim, p_getkey, "getkey" },
  { t_prim, p_serialinit, "serial.init" },
  { t_prim, p_serialputc, "serial.putc" },
  { t_prim, p_serialsetconfig, "serial.setconfig" },
  { t_prim, p_serialgetbaud, "serial.getbaud" },
  { t_prim, p_realpath, "realpath" },
  { t_prim, p_systempath, "systempath" },
  { t_prim, p_xxx, "xxx" },
  { t_prim, p_test1, "test1" },
  { t_prim, p_test2, "test2" },
  { t_prim, p_test3, "test3" },
  { t_prim, p_test4, "test4" },
  { t_prim, p_test5, "test5" },
  { t_prim, p_test6, "test6" }
};
